// OpenDialogDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OpenDialog.h"
#include "OpenDialogDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpenDialogDlg dialog

COpenDialogDlg::COpenDialogDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COpenDialogDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COpenDialogDlg)
	m_text = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void COpenDialogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COpenDialogDlg)
	DDX_Text(pDX, IDC_EDIT1, m_text);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COpenDialogDlg, CDialog)
	//{{AFX_MSG_MAP(COpenDialogDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpenDialogDlg message handlers

BOOL COpenDialogDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COpenDialogDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COpenDialogDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void COpenDialogDlg::OnBrowse() 
{
	OPENFILENAME OpnFileStruct; // structure for GetOpenFileName
	char szFile[256] = "\0";// Buffer for the filename
	// Size of structure
	OpnFileStruct.lStructSize       = sizeof(OPENFILENAME);
    // Handle to the parent window
	OpnFileStruct.hwndOwner         = this->GetSafeHwnd();
	// Filters
    OpnFileStruct.lpstrFilter       = "Text File\0*.txt\0WinZip\0*.zip";
    // Index for the filter
	OpnFileStruct.nFilterIndex      = 2;
    // Buffer which will recieve filename
	OpnFileStruct.lpstrFile         = szFile;
	// Size of buffer which will recieve filename
    OpnFileStruct.nMaxFile          = sizeof(szFile);
	// Title of the open dialog
    OpnFileStruct.lpstrTitle        = "Open Dialog Demo";
	// Flags
    OpnFileStruct.Flags             = OFN_FILEMUSTEXIST;
	// These can be ignored
	OpnFileStruct.hInstance         = NULL;
    OpnFileStruct.nFileOffset       = 0;
    OpnFileStruct.nFileExtension    = 0;
    OpnFileStruct.lpstrDefExt       = NULL;
    OpnFileStruct.lCustData         = NULL;
	OpnFileStruct.lpfnHook 		    = NULL;
	OpnFileStruct.lpTemplateName    = NULL;
    OpnFileStruct.lpstrFileTitle    = NULL;
    OpnFileStruct.nMaxFileTitle     = 0;
    OpnFileStruct.lpstrInitialDir   = NULL;
    OpnFileStruct.lpstrCustomFilter = NULL;
    OpnFileStruct.nMaxCustFilter    = 0;
    
	// Show open dialog box
	GetOpenFileName(&OpnFileStruct);
	// Update the edit box with the selected file
	m_text=szFile;
	UpdateData(false);	
}
